   --     ,  -
   --   .
   --     -
   --      :
   --
   --   [(A ,[x ,x ,...,x ]),...,(A ,[y ,y ,...,y ])],
   --      1   1  2      k         n   1  2      j
   --
   --     ,   
   --
   -- A   x , A  x ,..., A   x ,..., 
   --  1    1   1   2       1    k
   --
   -- A   y , A   y ,..., A   y .
   --  n    1   n    2       n    j
   --
   --   (  LISP): .. 
   --    Haskell: .. (28.01.2010)
   ----------------------------------------------------------
   module LibGrp_2
      (pairLis,reKey,reData,assoc1,rAssoc,putAssoc1,addArc,
       deleteNode,deleteArc,walk,neighb2,oneRange,listSet,assoc)
   where
   import List
   -----------------------------------------------------------
   --        KEY   
   --   DATA     
   --  Graph
   --------------------------------------------------------------
   pairLis:: [Integer] -> [[Integer]] -> [(Integer,[Integer])] ->
                                             [(Integer,[Integer])]
   pairLis key dta graph 
        | null key = graph
        | null dta = graph
        | elem (head key) (reKey graph)
                   = pairLis (tail key)
                             (tail dta)
                             (putAssoc1 (head key)
                                        (listSet
                                            (head dta ++
                                             (assoc1 (head key)
                                                     graph)))
                                        graph)
        | True     = (head key,head dta) :
                     pairLis (tail key) (tail dta) graph
   -----------------------------------------------------
   --     Graph  
   --   
   ------------------------------------------
   reKey:: [(Integer,[Integer])] -> [Integer]
   reKey graph | null graph = []
               | True       = fst (head graph) : reKey (tail graph)
   ----------------------------------------------------------------
   --      
   -- Graph    
   --------------------------------------------------
   reData:: [(Integer,[Integer])] -> [[Integer]]
   reData graph | null graph = []
                | True       = snd (head graph) : 
                               reData (tail graph)
   -----------------------------------------------------------
   --      Graph, 
   -- ,   Node
   ------------------------------------------------------
   assoc1:: Integer -> [(Integer,[Integer])] -> [Integer]
   assoc1 node graph | null graph = []
                     | fst (head graph)==node
                                  = snd (head graph)
                     | True       = assoc1 node (tail graph)
   ------------------------------------------------------------
   --       Graph,  
   --     LST
   --------------------------------------------------------
   rAssoc:: [Integer] -> [(Integer,[Integer])] -> [Integer]
   rAssoc lst graph | null graph = []
                    | sort (snd (head graph))==sort lst
                                 = [fst (head graph)]
                    | True       = rAssoc lst (tail graph)
   ---------------------------------------------------------
   --    Graph  ,   
   -- Key,   Data
   ------------------------------------------------------------
   putAssoc1:: Integer -> [Integer] -> [(Integer,[Integer])] -> 
                                              [(Integer,[Integer])]
   putAssoc1 key dta graph | null graph = []
                           | fst (head graph)/=key
                                        = head graph :
                                          putAssoc1 key dta 
                                                    (tail graph)
                           | True       = (fst (head graph),dta) :
                                          putAssoc1 key dta 
                                                    (tail graph)
   -------------------------------------------------------------
   --    Graph  (x,y)
   -------------------------------------------------------
   addArc:: Integer -> Integer -> [(Integer,[Integer])] -> 
                                              [(Integer,[Integer])]
   addArc x y graph | null graph = [(x,[y])]
                    | fst (head graph)==x &&
                      not (elem y (snd (head graph)))
                                 = putAssoc1 x 
                                             (y : snd (head graph)) 
                                             graph 
                    | fst (head graph)==x &&
                      elem y (snd (head graph))
                                 = graph
                    | True       = head graph : addArc x y
                                                       (tail graph)
   ----------------------------------------------------------------
   --   X   Graph
   ------------------------------------------------
   deleteNode:: Integer -> [(Integer,[Integer])] -> 
                                       [(Integer,[Integer])]
   deleteNode x graph 
        | (null graph) = []
        | fst (head graph)==x
                       = deleteNode x (tail graph)
        | elem x (snd (head graph)) 
                       = (fst (head graph),
                          filter (x/=) (snd (head graph))) :
                          deleteNode x (tail graph)
        | True         = head graph : deleteNode x (tail graph)
   ------------------------------------------------------------
   --   (X,Y)   Graph
   ----------------------------------------------------------
   deleteArc:: Integer -> Integer -> [(Integer,[Integer])] -> 
                                              [(Integer,[Integer])]
   deleteArc x y graph 
        | null graph = []
        | fst (head graph)==x && 
          elem y (snd (head graph))
                     = (x,filter (y/=) (snd (head graph))) :
                          deleteArc x y (tail graph)
        | True       = head graph : deleteArc x y (tail graph)
   --------------------------------------------------------------
   --  ,    , 
   --    Graph
   --------------------------------------------
   walk:: [(Integer,[Integer])] -> [Integer]
   walk graph | null graph = []
              | True       = sort (listSet (oneRange graph))
   ---------------------------------------------------------
   --    ""   X 
   --   Graph,     
   --  
   -------------------------------------------------------
   neighb2:: Integer -> [(Integer,[Integer])] -> [Integer]
   neighb2 x graph | null (assoc x graph (==))
                          = []
                   | True = snd (head (assoc x graph (==)))
   --------------------------------------------------------
   --   :
   --------------------------------------
   --    
   --
   --  ((A .(x  x ... x ))...(A .(y  y ... y ))),
   --     1   1  2     k       n   1  2     j
   --
   --   
   ---------------------------------------------
   oneRange:: [(Integer,[Integer])] -> [Integer]
   oneRange lst | null lst = []
                | True     = (fst (head lst) : snd (head lst)) 
                             ++ oneRange (tail lst)
   -------------------------------------------------------
   --    LST   
   -- (    )
   -----------------------------------------------
   listSet:: [Integer] -> [Integer]
   listSet lst | null lst = []
               | elem (head lst) (tail lst)
                          = listSet (tail lst)
               | True     = head lst : listSet (tail lst)
   -------------------------------------------------------------
   -- ,      
   -- alist ,        fst-  
   --  key   test    False.  
   --   ,    , ,  
   --     ;  -  
   ----------------------------------------------------------
   assoc:: Integer -> [(Integer,[Integer])] -> 
            (Integer -> Integer -> Bool) -> [(Integer,[Integer])]
   assoc key alist test | null alist = []
                        | test (fst (head alist)) key
                                     = [head alist]
                        | True       = assoc key (tail alist) test
